#ifndef BUDDY_H
#define BUDDY_H

#include "types.h"
#include "include/spinlock.h"

#define PGSIZE 4096
#define BUDDY_SYSTEM_SIZE 10 //PAGE NUMBERS

#define LEFT(i) (2 * (i) + 1)   // Index of the left child
#define RIGHT(i) (2 * (i) + 2)  // Index of the right child
#define PARENT(i) (((i) - 1) / 2) // Index of the parent

#define MAX(a, b) ((a) > (b) ? (a) : (b))

extern struct buddy buddy_system;



struct buddy {
    struct spinlock lock;
    uint64 base_addr;
    uint32 longest[(1 << (BUDDY_SYSTEM_SIZE + 1)) - 1];
};
 
void buddy_init(uint64 base);
uint64 buddy_alloc(uint64);
void buddy_free(uint64);


#endif