#ifndef BUDDY_H2
#define BUDDY_H2

#include "types.h"
#include "include/spinlock.h"

#define PGSIZE 4096

#define BUDDY_SYSTEM_SIZE 14 //PAGE NUMBERS
#define LAYER_NUM (BUDDY_SYSTEM_SIZE + 1)

#define LEFT(i) (2 * (i) + 1)   // Index of the left child
#define RIGHT(i) (2 * (i) + 2)  // Index of the right child
#define PARENT(i) (((i) - 1) / 2) // Index of the parent

#define MAX(a, b) ((a) > (b) ? (a) : (b))

struct tree_node {
    uint32 id;
    uint8 state;
    struct tree_node *next, *prev;
};

struct buddy_ {
    struct spinlock lock;
    uint64 base_addr;
    struct tree_node nodes[(1 << (LAYER_NUM + 1)) - 1];
    struct tree_node *freelists[LAYER_NUM];
};


extern struct buddy_ bdsys;

void buddy_init_(uint64 base);
uint64 buddy_alloc_(uint64 size);
void test_buddy_system();
void test_buddy_free();
void buddy_free_(uint64 addr);
#endif