#ifndef CFS_H
#define CFS_H

typedef enum {
  RED, 
  BLACK
} procColor;

#include "types.h"
#include "spinlock.h"
#include "proc.h"
#include "defs.h"

#define MAX_NICE 19
#define MIN_NICE -20
#define BASE_WEIGHT 1024

extern const int min_granularity;
extern const int latency;

struct RBTree {
  int count;
  int rbTreeWeight;
  struct proc *root;
  struct proc *min_vruntime_proc; //speed up searching
  struct spinlock lock;
  int period;
};

extern struct RBTree *rdy_queue;

void rotateLeft(struct RBTree *tree, struct proc *ptr);
void rotateRight(struct RBTree *tree, struct proc *ptr);

int insertProc(struct RBTree *tree, struct proc *node);
void printRBTree();
struct proc* rdyqueue_deq(struct RBTree *tree);
int preemptionTest(struct proc* current, struct proc* min_vruntime);

extern const int nice_weights[40];
struct proc* min_vruntime_proc(struct proc* node);
int getWeight(int nice);
void rbinit(struct RBTree *tree);


#endif