#ifndef VMA_H
#define VMA_H

#include "types.h"
#include "riscv.h"


#define VMA_FILE 0x1
#define VMA_HEAP 0x2
#define VMA_TEXT 0x4
#define VMA_STACK 0x8
#define VMA_ANON 0x16
#define VMA_DATA 0x32

struct vm_area_struct {
    uint64 vm_start;          
    uint64 vm_end;            
    struct vm_area_struct *vm_next, *vm_prev;  
    int vm_flags;
    int vm_prot;          
    struct file *vm_file;   
    uint64 vm_pgoff;          
    uint64 vm_filesz;
    uint32 vma_type;//mask
};

struct mm_struct {
    struct vm_area_struct *mmap;
    uint64 lower_bound;
};

void init_mm_struct(struct mm_struct *mm);
struct vm_area_struct *find_vma(struct mm_struct *mm, uint64 addr);
uint64 do_mmap(struct mm_struct *mm, uint64 addr, uint64 len, uint64 vm_pgoff, uint64 vm_filesz, int flags, struct file *f, int prot, int vma_type);
int test_vma_all_unmapped(struct vm_area_struct *vma);
int unmap_all_vma(struct mm_struct *mm);
struct vm_area_struct *copy_vma_list(struct vm_area_struct *parent_vma);
void print_vma(struct vm_area_struct *vma);
void print_vma_list(struct vm_area_struct *head);
#endif