#include "../kernel/include/syscall.h"
#include "../kernel/include/types.h"
#include "../kernel/include/stat.h"
#include "user.h"


int
main(int argc, char *argv[])
{
  int i;
  char *nargv[10];

  if(argc < 3 || (argv[1][0] < '0' || argv[1][0] > '9')){
    fprintf(2, "Usage: %s tracemask pathname_to_executables\n", argv[0]);
    exit(1);
  }
  
  uint64 tracemask = 0;
  const char *s = argv[1];
  while(*s >= '0' && *s <= '9'){
    tracemask = 10 * tracemask + (*s - '0');
    s++;
  }

  if (trace(tracemask) < 0) {
    fprintf(2, "%s: trace failed\n", argv[0]);
    exit(1);
  }
  
  for(i = 2; i < argc && i < 10; i++){
    nargv[i-2] = argv[i];
  }
  nargv[argc-2] = 0;
  exec(nargv[0], nargv);
  printf("trace: exec failed\n");
  exit(0);
}
